/// <reference types="node" />
import * as React from 'react';
export interface ScrollBarProps {
    prefixCls: string;
    scrollTop: number;
    scrollHeight: number;
    height: number;
    count: number;
    onScroll: (scrollTop: number) => void;
    onStartMove: () => void;
    onStopMove: () => void;
}
interface ScrollBarState {
    dragging: boolean;
    pageY: number;
    startTop: number;
    visible: boolean;
}
export default class ScrollBar extends React.Component<ScrollBarProps, ScrollBarState> {
    moveRaf: number;
    visibleTimeout: NodeJS.Timeout;
    state: ScrollBarState;
    componentDidUpdate(prevProps: ScrollBarProps): void;
    componentWillUnmount(): void;
    delayHidden: () => void;
    patchEvents: () => void;
    removeEvents: () => void;
    onContainerMouseDown: React.MouseEventHandler;
    onMouseDown: React.MouseEventHandler;
    onMouseMove: (e: MouseEvent) => void;
    onMouseUp: () => void;
    getSpinHeight: () => number;
    getEnableScrollRange: () => number;
    getEnableHeightRange: () => number;
    getTop: () => number;
    render(): JSX.Element;
}
export {};
